#ifdef WIN32
    #include <winsock2.h>
    #include  <ws2tcpip.h>
#endif
#include <stdio.h>
#include <time.h>
#include "uSQLite\gLog.h"
#include "uSQLite\uSQLst.h"

////// This is just a container.
////// The 'real' server is in uSQLst and the individual client code is
////// in uSQLct. Main just sets up and invokes an instance of uSQLst.
////// In the future uSQLst and beyond will be packed as a library, all
////// configuration params should be passed througth the init function.

pLog Log;

int main(int argc, char *argv[])
{
uSQLst *s1;

int cycle=0;
FILE *inifile;
char mdb[100],sdb[100],inbuff[150];
int portnum,maxclients,maxbuffer,MaxRetRec,MaxQlength,MaxRepRecs,initStrt,initEnd;
int ln=0,rets;
int err,d29cnt=0;

#ifdef WIN32
WORD vr;
WSADATA ws;


    vr=MAKEWORD(2,0);
    if(WSAStartup(vr,&ws)){
    	fprintf(stderr,"This program requires winsock 2 DLL or higher\r");
    	return 1;
    }
#else
    struct timespec stime,ttime;
#endif


    Log=gLog;

    if(argc!=2){
        Log("uSQLserver","Must pass ini file as argument",0);
        return 1;
    }

    // TODO: Of course the .ini file should be a .db3 file!

    if(!(inifile=fopen(argv[1],"r"))){
    	Log("uSQLserver","Cannot open ini file",0);
    	return 1;
    }

    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%99s",mdb))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%99s",sdb))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&portnum))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&maxclients))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&maxbuffer))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&MaxRetRec))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&MaxQlength))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&MaxRepRecs))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&initStrt))!=1)goto fail;
    ln++;
    if(!fgets(inbuff,150,inifile))goto fail;
    if((sscanf(inbuff,"%i",&initEnd))!=1)goto fail;

    fclose(inifile);

    Log("uSQLserver","uSQL service 1 starting",0);

    if(!(s1=uSQLstInit(Log,mdb,sdb,/*port*/portnum,/*maxclients*/maxclients,/*maxbuffer*/maxbuffer,/*MaxRetRec*/MaxRetRec,/*int MaxQlength*/MaxQlength,/*int MaxRepRecs*/MaxRepRecs))){
        Log("uSQLserver","Failed to start service 1",0);
        return 1;
    }

    // TODO: Put this in st and invoke at end of init
    rets=execDB(s1->db,initStrt,initEnd);
    if(rets!=initEnd+1){
    	sprintf(inbuff,"Failed init queries at %i",rets);
    	Log("uSQLserver",inbuff,0);
    	return 1;
    }


    // This server is designed to work as a single process on a single
    // thread. Poll must be called periodicaly to give it a time slice
    // to run round the clients and do any servicing required.
    // 
    // Increasing sleep time increases latency (time to start servicing
    // a request).
    // It dosn't actually take much effort to do an 'empty turn' so I keep
    // this small.

    while(1){
#ifdef WIN32
        Sleep(3);
#else
        stime.tv_sec=0;
        stime.tv_nsec=3000000;
    	nanosleep(&stime,&ttime);
#endif
        if(++cycle==30)cycle=0;
    	uSQLstPoll(s1,cycle);
    }

fail:
    sprintf(inbuff,"Failed parsing ini file at line %i",ln);
    Log("uSQLserver",inbuff,0);
    fclose(inifile);

}
