
#include <stdlib.h>
#include <string.h>
#include "Chunk.h"

    

Chunk *MakeChunk(){
Chunk *newch;

    newch=(Chunk*)malloc(sizeof(Chunk));
    if(newch){
        newch->first=NULL;
        newch->last=NULL;
    }
    return newch;
}

int ChunkAdd(Chunk *ch,char *src,size_t sz){
struct chunk *newchunk;		
			
		newchunk=(struct chunk*)malloc(sizeof(struct chunk)+sz);
		if(!newchunk)return -1;
		newchunk->sz=sz;
		newchunk->next=NULL;
		
		if(!ch->last){
			ch->first=ch->last=newchunk;
			ch->nettote=sz;
			ch->grosstote=sz+sizeof(struct chunk);
			ch->consumed=0;
		}
		else{
			ch->last->next=newchunk;
			ch->last=newchunk;
			ch->nettote+=sz;
			ch->grosstote+=sz+sizeof(struct chunk);
		}
		memcpy((char*)newchunk+sizeof(struct chunk),src,sz);
		return 0;
}

size_t ChunkGrossSize(Chunk *ch){
	return ch->first? ch->grosstote:0;
}

size_t ChunkNettSize(Chunk *ch){
	return ch->first? ch->nettote:0;
}

size_t ChunkLeadSz(Chunk *ch){
	return ch->first? ch->first->sz-ch->consumed:0;
}

void ChunkConsume(Chunk *ch,size_t sz){
struct chunk *oldchunk;

	if(!ch->first)return;
	
	ch->consumed+=sz;
		
	// If we have used up the packet, move up to the next
	if(ch->consumed>=ch->first->sz){
		oldchunk=ch->first;
		if(ch->first->next){
			ch->first=oldchunk->next;
			ch->nettote-=oldchunk->sz;
			ch->grosstote-=oldchunk->sz+sizeof(struct chunk);
			ch->consumed=0;
		}
		else{
			ch->first=ch->last=NULL;
		}

		free(oldchunk);
	}
}

char *ChunkLead(Chunk *ch){
	return ch->first? ((char*)ch->first)+ch->consumed+sizeof(struct chunk):NULL;
}

// MoveTo is also an example of how to get data out of a Chunk.
// (Which is also why it only uses public methods instead of private fields ;-)
// Because MoveTo knows about the linked list structure it is
// not limited by packet boundries.
size_t ChunkMoveTo(Chunk *ch,char *dest,size_t max){
size_t moved=0;
int togo;	

	while((togo=max-moved)>0){
		if(!ch->first)break;
		if(togo>ChunkLeadSz(ch))togo=ChunkLeadSz(ch);
		memcpy(dest,ChunkLead(ch),togo);
		dest+=togo;
		moved+=togo;
		ChunkConsume(ch,togo);
	}			
	return moved;
}

// Eat everything up before we exit
void ChunkDestroy(Chunk *ch){
	while(ch->first)ChunkConsume(ch,ChunkLeadSz(ch));
	free(ch);			
}
	
